=== debian/changelog ===
serd (0.14.0~dfsg0-2) unstable; urgency=low

  * Add patch to prevent FTBFS on kfreebsd.
  * Update debian/copyright.

 -- Alessio Treglia <alessio@debian.org>  Thu, 19 Apr 2012 13:31:01 +0200

serd (0.14.0~dfsg0-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches.
  * Refresh symbols file.
  * Bump debhelper requirement to 9.
  * Put in serd-dbg only symbols from libserd-0-0.
  * Set 'xz' as upstream tarball compression format.
  * Update debian/copyright's format.
  * debian/watch: Mangle dfsg suffix.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Thu, 19 Apr 2012 11:48:16 +0200
