=== debian/control ===
Source: serd
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 9),
 pkg-config,
 python
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 3.9.3
Homepage: http://drobilla.net/software/serd/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/serd.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/serd.git

Package: libserd-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libserd-0-0 (= ${binary:Version}),
 ${misc:Depends}
Recommends:
 pkg-config
Suggests:
 libserd-doc
Description: lightweight RDF syntax library - development files
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the development files for Serd.

Package: libserd-0-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 serdi
Description: lightweight RDF syntax library
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 Serd is not intended to be a swiss-army knife of RDF syntax, but rather
 is suited to resource limited applications, or situations where a simple
 reader/writer with minimal dependencies is ideal (e.g. in LV2 hosts or
 plugins).
 .
 Serd is:
  * small: Serd is implemented in under 2500 lines1 of standard C code.
  * portable and dependency-free: Serd uses only the C standard library,
    and has no external dependencies, making it a lightweight dependency
    in every sense.
  * fast and lightweight: Serd (and the included serdi tool) can be used
    to stream abbreviated Turtle (unlike many other tools which can not
    stream since they must first build an internal model to abbreviate).
    In other words, Serd can re-serialise an unbounded amount of Turtle
    using a fixed amount of memory, preserving the abbreviations in the
    input.
  * conformant and well-tested: Serd is written to the Turtle, NTriples
    and URI specifications, and includes a comprehensive test suite which
    includes all the normative examples from the Turtle specification, all
    the "normal" examples from the URI specification, and additional tests
    added specifically for Serd. The test suite has over 96% code coverage
    (by line), and runs with zero memory errors or leaks.

Package: serdi
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight RDF syntax library - serdi tool
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the utility 'serdi'.

Package: libserd-doc
Section: doc
Architecture: all
Enhances:
 libserd-dev
Depends:
 ${misc:Depends}
Description: lightweight RDF syntax library - documentation
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the developer's reference for serd.

Package: serd-dbg
Architecture: any
Multi-Arch: same
Priority: extra
Section: debug
Depends:
 libserd-0-0 (= ${binary:Version}),
 ${misc:Depends}
Description: lightweight RDF syntax library - debugging symbols
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package contains the debugging symbols for serd.
