=== debian/changelog ===
serd (0.18.0~dfsg0-1) experimental; urgency=low

  * New upstream release.
  * Refresh patches.
  * Update symbols.
  * Implement a mechanism to automatically repack the tarball.
  * Install NEWS as upstream changelog.

 -- Alessio Treglia <alessio@debian.org>  Sun, 02 Sep 2012 17:18:54 +0200
