## serd 0.18.2~dfsg0

=== debian/changelog ===
serd (0.18.2~dfsg0-2) unstable; urgency=low

  * Upload to unstable.
  * Fix Vcs URLs.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Tue, 07 May 2013 09:54:54 +0200

serd (0.18.2~dfsg0-1) experimental; urgency=low

  * New upstream release.
  * Refresh patches.
  * Fix debian/libserd-doc.install.

 -- Alessio Treglia <alessio@debian.org>  Sat, 29 Dec 2012 15:53:15 +0000
