=== debian/control ===
--- 
+++ 
@@ -11,10 +11,10 @@
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://drobilla.net/software/serd/
-Vcs-Git: git://git.debian.org/git/pkg-multimedia/serd.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/serd.git
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/serd.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/serd.git
 
 Package: libserd-dev
 Section: libdevel
