## serd 0.20.0~dfsg1

=== debian/changelog ===
serd (0.20.0~dfsg1-1) unstable; urgency=medium

  [ Jaromír Mikeš ]
  * New upstream release.
  * Added myself as uploader
  * Tuned get-orig-source.
  * Remove --debug from configure to cppflags be passed.
  * Bump Standards.

  [ Alessio Treglia ]
  * Refresh patches.

 -- Alessio Treglia <alessio@debian.org>  Fri, 15 Aug 2014 15:59:51 +0100
