## serd 0.22.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -3,28 +3,22 @@
 import os
 import shutil
 import subprocess
-
-from waflib.extras import autowaf as autowaf
-import waflib.Logs as Logs, waflib.Options as Options
-
-# Version of this package (even if built as a child)
-SERD_VERSION       = '0.18.0'
-SERD_MAJOR_VERSION = '0'
-
-# Library version (UNIX style major, minor, micro)
+import waflib.Logs as Logs
+import waflib.Options as Options
+import waflib.extras.autowaf as autowaf
+
+# Library and package version (UNIX style major, minor, micro)
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-# Serd uses the same version number for both library and package
-SERD_LIB_VERSION = SERD_VERSION
-
-# Variables for 'waf dist'
-APPNAME = 'serd'
-VERSION = SERD_VERSION
-
-# Mandatory variables
-top = '.'
-out = 'build'
+SERD_VERSION       = '0.22.0'
+SERD_MAJOR_VERSION = '0'
+
+# Mandatory waf variables
+APPNAME = 'serd'        # Package name for waf dist
+VERSION = SERD_VERSION  # Package version for waf dist
+top     = '.'           # Source directory
+out     = 'build'       # Build directory
 
 def options(opt):
     opt.load('compiler_c')
@@ -33,6 +27,8 @@
                    help='Do not build command line utilities')
     opt.add_option('--test', action='store_true', dest='build_tests',
                    help='Build unit tests')
+    opt.add_option('--no-coverage', action='store_true', dest='no_coverage',
+                   help='Do not use gcov for code coverage')
     opt.add_option('--stack-check', action='store_true', dest='stack_check',
                    help='Include runtime stack sanity checks')
     opt.add_option('--static', action='store_true', dest='static',
@@ -43,12 +39,14 @@
                    help='Build programs as static binaries')
     opt.add_option('--largefile', action='store_true', dest='largefile',
                    help='Build with large file support on 32-bit systems')
+    opt.add_option('--no-posix', action='store_true', dest='no_posix',
+                   help='Do not use posix_memalign, posix_fadvise, and fileno, even if present')
 
 def configure(conf):
     conf.load('compiler_c')
     autowaf.configure(conf)
+    autowaf.display_header('Serd Configuration')
     autowaf.set_c99_mode(conf)
-    autowaf.display_header('Serd Configuration')
 
     conf.env.BUILD_TESTS  = Options.options.build_tests
     conf.env.BUILD_UTILS  = not Options.options.no_utils
@@ -66,50 +64,34 @@
     if Options.options.largefile:
         conf.env.append_unique('DEFINES', ['_FILE_OFFSET_BITS=64'])
 
-    # Check for gcov library (for test coverage)
-    if conf.env.BUILD_TESTS:
-        conf.check_cc(lib='gcov',
-                      define_name='HAVE_GCOV',
-                      mandatory=False)
-
-    # Check for fmax
-    conf.check(function_name='fmax',
-               header_name='math.h',
-               define_name='HAVE_FMAX',
-               lib=['m'],
-               mandatory=False)
-
-    # Check for posix_memalign
-    conf.check(function_name='posix_memalign',
-               header_name='stdlib.h',
-               define_name='HAVE_POSIX_MEMALIGN',
-               defines=['_POSIX_C_SOURCE=201112L'],
-               mandatory=False)
-
-    # Check for posix_fadvise
-    conf.check(function_name='posix_fadvise',
-               header_name='fcntl.h',
-               define_name='HAVE_POSIX_FADVISE',
-               defines=['_POSIX_C_SOURCE=201112L'],
-               mandatory=False)
-
-    # Check for fileno
-    conf.check(function_name='fileno',
-               header_name='stdio.h',
-               define_name='HAVE_FILENO',
-               defines=['_POSIX_C_SOURCE=201112L'],
-               mandatory=False)
+    if conf.env.BUILD_TESTS and not Options.options.no_coverage:
+        conf.check_cc(lib='gcov', define_name='HAVE_GCOV', mandatory=False)
+
+    if not Options.options.no_posix:
+        conf.check(function_name = 'posix_memalign',
+                   header_name   = 'stdlib.h',
+                   define_name   = 'HAVE_POSIX_MEMALIGN',
+                   defines       = ['_POSIX_C_SOURCE=201112L'],
+                   mandatory     = False)
+
+        conf.check(function_name = 'posix_fadvise',
+                   header_name   = 'fcntl.h',
+                   define_name   = 'HAVE_POSIX_FADVISE',
+                   defines       = ['_POSIX_C_SOURCE=201112L'],
+                   mandatory     = False)
+
+        conf.check(function_name = 'fileno',
+                   header_name   = 'stdio.h',
+                   define_name   = 'HAVE_FILENO',
+                   defines       = ['_POSIX_C_SOURCE=201112L'],
+                   mandatory     = False)
 
     autowaf.define(conf, 'SERD_VERSION', SERD_VERSION)
+    autowaf.set_lib_env(conf, 'serd', SERD_VERSION)
     conf.write_config_header('serd_config.h', remove=False)
 
-    conf.env.INCLUDES_SERD = ['%s/serd-%s' % (conf.env.INCLUDEDIR,
-                                              SERD_MAJOR_VERSION)]
-    conf.env.LIBPATH_SERD = [conf.env.LIBDIR]
-    conf.env.LIB_SERD = ['serd-%s' % SERD_MAJOR_VERSION];
-
-    autowaf.display_msg(conf, 'Utilities', str(conf.env.BUILD_UTILS))
-    autowaf.display_msg(conf, 'Unit tests', str(conf.env.BUILD_TESTS))
+    autowaf.display_msg(conf, 'Utilities', bool(conf.env.BUILD_UTILS))
+    autowaf.display_msg(conf, 'Unit tests', bool(conf.env.BUILD_TESTS))
     print('')
 
 lib_source = [
@@ -147,7 +129,7 @@
             lib             = libs,
             name            = 'libserd',
             target          = 'serd-%s' % SERD_MAJOR_VERSION,
-            vnum            = SERD_LIB_VERSION,
+            vnum            = SERD_VERSION,
             install_path    = '${LIBDIR}',
             defines         = defines + ['SERD_SHARED', 'SERD_INTERNAL'],
             cflags          = libflags)
@@ -161,7 +143,7 @@
             lib             = libs,
             name            = 'libserd_static',
             target          = 'serd-%s' % SERD_MAJOR_VERSION,
-            vnum            = SERD_LIB_VERSION,
+            vnum            = SERD_VERSION,
             install_path    = '${LIBDIR}',
             defines         = defines + ['SERD_INTERNAL'])
 
@@ -268,6 +250,9 @@
 
 def upload_docs(ctx):
     os.system('rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/serd/')
+    for page in glob.glob('doc/*.[1-8]'):
+        os.system('soelim %s | pre-grohtml troff -man -wall -Thtml | post-grohtml > build/%s.html' % (page, page))
+        os.system('rsync -avz --delete -e ssh build/%s.html drobilla@drobilla.net:~/drobilla.net/man/' % page)
 
 def file_equals(patha, pathb, subst_from='', subst_to=''):
     fa = open(patha, 'rU')
@@ -279,67 +264,65 @@
     fb.close()
     return True
 
-def test(ctx):
-    blddir = autowaf.build_dir(APPNAME, 'tests')
-    try:
-        os.makedirs(blddir)
-    except:
-        pass
-
-    for i in glob.glob(blddir + '/*.*'):
-        os.remove(i)
-
-    srcdir   = ctx.path.abspath()
-    orig_dir = os.path.abspath(os.curdir)
-
-    os.chdir(srcdir)
-
-    good_tests = glob.glob('tests/test-*.ttl')
-    good_tests.sort()
-
-    bad_tests = glob.glob('tests/bad-*.ttl')
-    bad_tests.sort()
-
-    os.chdir(orig_dir)
-
-    autowaf.pre_test(ctx, APPNAME)
-
-    os.environ['PATH'] = '.' + os.pathsep + os.getenv('PATH')
-
-    autowaf.run_tests(ctx, APPNAME, ['serd_test'], dirs=['.'])
-
-    autowaf.run_tests(ctx, APPNAME, [
-            'serdi_static -o turtle %s/tests/base.ttl "base.ttl" > tests/base.ttl.out' % srcdir],
-                      0, name='base')
-
-    if not file_equals('%s/tests/base.ttl' % srcdir, 'tests/base.ttl.out'):
-        Logs.pprint('RED', 'FAIL: build/tests/base.ttl.out is incorrect')
-
-    nul = os.devnull
-    autowaf.run_tests(ctx, APPNAME, [
-            'serdi_static file://%s/tests/manifest.ttl > %s' % (srcdir, nul),
-            'serdi_static %s/tests/UTF-8.ttl > %s' % (srcdir, nul),
-            'serdi_static -v > %s' % nul,
-            'serdi_static -h > %s' % nul,
-            'serdi_static -s "<foo> a <#Thingie> ." > %s' % nul,
-            'serdi_static %s > %s' % (nul, nul)],
-                      0, name='serdi-cmd-good')
-
-    autowaf.run_tests(ctx, APPNAME, [
-            'serdi_static -q file://%s/tests/bad-id-clash.ttl > %s' % (srcdir, nul),
-            'serdi_static > %s' % nul,
-            'serdi_static ftp://example.org/unsupported.ttl > %s' % nul,
-            'serdi_static -i > %s' % nul,
-            'serdi_static -o > %s' % nul,
-            'serdi_static -z > %s' % nul,
-            'serdi_static -p > %s' % nul,
-            'serdi_static -c > %s' % nul,
-            'serdi_static -r > %s' % nul,
-            'serdi_static -i illegal > %s' % nul,
-            'serdi_static -o illegal > %s' % nul,
-            'serdi_static -i turtle > %s' % nul,
-            'serdi_static /no/such/file > %s' % nul],
-                      1, name='serdi-cmd-bad')
-
-    commands = []
-    for test in good_tests:
+def earl_assertion(test, passed, asserter):
+    import datetime
+
+    asserter_str = ''
+    if asserter is not None:
+        asserter_str = '\n\tearl:assertedBy <%s> ;' % asserter
+
+    passed_str = 'earl:failed'
+    if passed:
+        passed_str = 'earl:passed'
+
+    return '''
+[]
+	a earl:Assertion ;%s
+	earl:subject <http://drobilla.net/sw/serd> ;
+	earl:test <%s> ;
+	earl:result [
+		a earl:TestResult ;
+		earl:outcome %s ;
+		dc:date "%s"^^xsd:dateTime
+	] .
+''' % (asserter_str,
+       test,
+       passed_str,
+       datetime.datetime.now().replace(microsecond=0).isoformat())
+
+def test_thru(ctx, base, path, check_filename, flags):
+    in_filename = os.path.join(ctx.path.abspath(), path);
+    out_filename = path + '.thru'
+
+    command = ('%s %s -i turtle -o turtle -p foo "%s" "%s" | '
+               '%s -i turtle -o ntriples -c foo - "%s" > %s') % (
+        'serdi_static', flags.ljust(5),
+        in_filename, base,
+        'serdi_static', base, out_filename)
+
+    passed = autowaf.run_test(ctx, APPNAME, command, 0, name=out_filename)
+    if not passed:
+        Logs.pprint('RED', '** Failed command: %s' % command)
+        return False
+
+    if not os.access(out_filename, os.F_OK):
+        Logs.pprint('RED', 'FAIL: %s is missing' % out_filename)
+    elif not file_equals(check_filename, out_filename, '_:docid', '_:genid'):
+        Logs.pprint('RED', 'FAIL: %s != %s' % (out_filename, check_filename))
+    else:
+        #Logs.pprint('GREEN', '** Pass %s == %s' % (out_filename, check_filename))
+        return True
+
+    return False
+
+def test_manifest(ctx, srcdir, testdir, report, base_uri):
+    import rdflib
+    import urlparse
+
+    rdf  = rdflib.Namespace('http://www.w3.org/1999/02/22-rdf-syntax-ns#')
+    rdfs = rdflib.Namespace('http://www.w3.org/2000/01/rdf-schema#')
+    mf   = rdflib.Namespace('http://www.w3.org/2001/sw/DataAccess/tests/test-manifest#')
+    rdft = rdflib.Namespace('http://www.w3.org/ns/rdftest#')
+    earl = rdflib.Namespace('http://www.w3.org/ns/earl#')
+
+    model = rdflib.ConjunctiveGraph()
