=== debian/changelog ===
serd (0.22.0~dfsg0-2) unstable; urgency=medium

  * Patches forwarded.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 13 Oct 2015 18:50:01 +0200

serd (0.22.0~dfsg0-1) unstable; urgency=medium

  [ IOhannes m zmölnig ]
  * Patched waf to find generated docs.
  * Remove lock file in 'clean' target.

  [ Jaromír Mikeš ]
  * Update symbols file.
  * Enable parallel build.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 12 Oct 2015 21:20:13 +0200
