=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://drobilla.net/software/serd/
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/serd.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/serd.git
