=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 endif
 
 %:
-	dh $@
+	dh $@ --parallel
 
 override_dh_auto_configure:
 	$(WAF) configure \
@@ -30,6 +30,7 @@
 	$(WAF) clean || true
 	find -name "*.pyc" -delete
 	rm -rf build .waf*
+	rm -rf .lock-*_build
 	dh_auto_clean
 
 override_dh_auto_install:
